import { ChangeDetectorRef, ElementRef, EventEmitter, NgZone } from "@angular/core";
import { Components } from "@camunda-cloud/common-ui";
export declare interface CmBanner extends Components.CmBanner {
}
export declare class CmBanner {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmButton extends Components.CmButton {
}
export declare class CmButton {
    protected z: NgZone;
    cmPress: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmCard extends Components.CmCard {
}
export declare class CmCard {
    protected z: NgZone;
    cmDismissed: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmCheckbox extends Components.CmCheckbox {
}
export declare class CmCheckbox {
    protected z: NgZone;
    cmInput: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmCheckboxGroup extends Components.CmCheckboxGroup {
}
export declare class CmCheckboxGroup {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmContext extends Components.CmContext {
}
export declare class CmContext {
    protected z: NgZone;
    themeChanged: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmDatalist extends Components.CmDatalist {
}
export declare class CmDatalist {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmDatalistItem extends Components.CmDatalistItem {
}
export declare class CmDatalistItem {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmDropdown extends Components.CmDropdown {
}
export declare class CmDropdown {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmEntityList extends Components.CmEntityList {
}
export declare class CmEntityList {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmFilter extends Components.CmFilter {
}
export declare class CmFilter {
    protected z: NgZone;
    cmFilterSelected: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmFooter extends Components.CmFooter {
}
export declare class CmFooter {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmForm extends Components.CmForm {
}
export declare class CmForm {
    protected z: NgZone;
    cmSubmit: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmFormGroup extends Components.CmFormGroup {
}
export declare class CmFormGroup {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmHeader extends Components.CmHeader {
}
export declare class CmHeader {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmIcon extends Components.CmIcon {
}
export declare class CmIcon {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmIconButton extends Components.CmIconButton {
}
export declare class CmIconButton {
    protected z: NgZone;
    cmPress: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmLink extends Components.CmLink {
}
export declare class CmLink {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmLoader extends Components.CmLoader {
}
export declare class CmLoader {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmLogo extends Components.CmLogo {
}
export declare class CmLogo {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmModal extends Components.CmModal {
}
export declare class CmModal {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmNotification extends Components.CmNotification {
}
export declare class CmNotification {
    protected z: NgZone;
    cmDismissed: EventEmitter<CustomEvent>;
    cmNotificationNavigation: EventEmitter<CustomEvent>;
    didLoad: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmNotificationContainer extends Components.CmNotificationContainer {
}
export declare class CmNotificationContainer {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmPage extends Components.CmPage {
}
export declare class CmPage {
    protected z: NgZone;
    tabChanged: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmPageTab extends Components.CmPageTab {
}
export declare class CmPageTab {
    protected z: NgZone;
    tabModified: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmPageTabHandle extends Components.CmPageTabHandle {
}
export declare class CmPageTabHandle {
    protected z: NgZone;
    userSelectedTab: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmRadiobutton extends Components.CmRadiobutton {
}
export declare class CmRadiobutton {
    protected z: NgZone;
    cmSelected: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmRadiobuttonGroup extends Components.CmRadiobuttonGroup {
}
export declare class CmRadiobuttonGroup {
    protected z: NgZone;
    cmInput: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmSelect extends Components.CmSelect {
}
export declare class CmSelect {
    protected z: NgZone;
    cmInput: EventEmitter<CustomEvent>;
    cmReset: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmSelectFlyout extends Components.CmSelectFlyout {
}
export declare class CmSelectFlyout {
    protected z: NgZone;
    cmInput: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmText extends Components.CmText {
}
export declare class CmText {
    protected z: NgZone;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmTextfield extends Components.CmTextfield {
}
export declare class CmTextfield {
    protected z: NgZone;
    cmInput: EventEmitter<CustomEvent>;
    cmReset: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
export declare interface CmToggle extends Components.CmToggle {
}
export declare class CmToggle {
    protected z: NgZone;
    cmInput: EventEmitter<CustomEvent>;
    protected el: HTMLElement;
    constructor(c: ChangeDetectorRef, r: ElementRef, z: NgZone);
}
