import { __decorate, __metadata } from 'tslib';
import { Component, ChangeDetectionStrategy, ChangeDetectorRef, ElementRef, NgZone, NgModule } from '@angular/core';
import { fromEvent } from 'rxjs';
import { defineCustomElements } from '@camunda-cloud/common-ui/loader';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const proxyInputs = (/**
 * @param {?} Cmp
 * @param {?} inputs
 * @return {?}
 */
(Cmp, inputs) => {
    /** @type {?} */
    const Prototype = Cmp.prototype;
    inputs.forEach((/**
     * @param {?} item
     * @return {?}
     */
    item => {
        Object.defineProperty(Prototype, item, {
            /**
             * @return {?}
             */
            get() {
                return this.el[item];
            },
            /**
             * @param {?} val
             * @return {?}
             */
            set(val) {
                this.z.runOutsideAngular((/**
                 * @return {?}
                 */
                () => (this.el[item] = val)));
            }
        });
    }));
});
/** @type {?} */
const proxyMethods = (/**
 * @param {?} Cmp
 * @param {?} methods
 * @return {?}
 */
(Cmp, methods) => {
    /** @type {?} */
    const Prototype = Cmp.prototype;
    methods.forEach((/**
     * @param {?} methodName
     * @return {?}
     */
    methodName => {
        Prototype[methodName] = (/**
         * @return {?}
         */
        function () {
            /** @type {?} */
            const args = arguments;
            return this.z.runOutsideAngular((/**
             * @return {?}
             */
            () => this.el[methodName].apply(this.el, args)));
        });
    }));
});
/** @type {?} */
const proxyOutputs = (/**
 * @param {?} instance
 * @param {?} el
 * @param {?} events
 * @return {?}
 */
(instance, el, events) => {
    events.forEach((/**
     * @param {?} eventName
     * @return {?}
     */
    eventName => instance[eventName] = fromEvent(el, eventName)));
});
/**
 * @param {?} opts
 * @return {?}
 */
function ProxyCmp(opts) {
    /** @type {?} */
    const decorator = (/**
     * @param {?} cls
     * @return {?}
     */
    function (cls) {
        if (opts.inputs) {
            proxyInputs(cls, opts.inputs);
        }
        if (opts.methods) {
            proxyMethods(cls, opts.methods);
        }
        return cls;
    });
    return decorator;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
let CmBanner = class CmBanner {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
CmBanner.decorators = [
    { type: Component, args: [{ selector: "cm-banner", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["appearance"] },] },
];
/** @nocollapse */
CmBanner.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmBanner = __decorate([
    ProxyCmp({ inputs: ["appearance"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmBanner);
let CmButton = class CmButton {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["cmPress"]);
    }
};
CmButton.decorators = [
    { type: Component, args: [{ selector: "cm-button", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["appearance", "disabled", "label", "loading", "size"] },] },
];
/** @nocollapse */
CmButton.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmButton = __decorate([
    ProxyCmp({ inputs: ["appearance", "disabled", "label", "loading", "size"], "methods": ["press"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmButton);
let CmCard = class CmCard {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["cmDismissed"]);
    }
};
CmCard.decorators = [
    { type: Component, args: [{ selector: "cm-card", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["isDismissable"] },] },
];
/** @nocollapse */
CmCard.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmCard = __decorate([
    ProxyCmp({ inputs: ["isDismissable"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmCard);
let CmCheckbox = class CmCheckbox {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["cmInput"]);
    }
};
CmCheckbox.decorators = [
    { type: Component, args: [{ selector: "cm-checkbox", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["checked", "disabled", "enableAttributeEmit", "formName", "helperText", "icon", "indeterminate", "label", "required"] },] },
];
/** @nocollapse */
CmCheckbox.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmCheckbox = __decorate([
    ProxyCmp({ inputs: ["checked", "disabled", "enableAttributeEmit", "formName", "helperText", "icon", "indeterminate", "label", "required"], "methods": ["toggleCheck", "check", "uncheck", "reset", "forceFocus", "checkValidity", "renderValidity", "hideValidity"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmCheckbox);
let CmCheckboxGroup = class CmCheckboxGroup {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
CmCheckboxGroup.decorators = [
    { type: Component, args: [{ selector: "cm-checkbox-group", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["label"] },] },
];
/** @nocollapse */
CmCheckboxGroup.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmCheckboxGroup = __decorate([
    ProxyCmp({ inputs: ["label"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmCheckboxGroup);
let CmContext = class CmContext {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["themeChanged"]);
    }
};
CmContext.decorators = [
    { type: Component, args: [{ selector: "cm-context", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["theme"] },] },
];
/** @nocollapse */
CmContext.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmContext = __decorate([
    ProxyCmp({ inputs: ["theme"], "methods": ["getVariableValue", "getResolvedTheme"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmContext);
let CmDatalist = class CmDatalist {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
CmDatalist.decorators = [
    { type: Component, args: [{ selector: "cm-datalist", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["headline", "labelWidth"] },] },
];
/** @nocollapse */
CmDatalist.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmDatalist = __decorate([
    ProxyCmp({ inputs: ["headline", "labelWidth"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmDatalist);
let CmDatalistItem = class CmDatalistItem {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
CmDatalistItem.decorators = [
    { type: Component, args: [{ selector: "cm-datalist-item", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["label", "labelWidth"] },] },
];
/** @nocollapse */
CmDatalistItem.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmDatalistItem = __decorate([
    ProxyCmp({ inputs: ["label", "labelWidth"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmDatalistItem);
let CmDropdown = class CmDropdown {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
CmDropdown.decorators = [
    { type: Component, args: [{ selector: "cm-dropdown", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["options", "trigger"] },] },
];
/** @nocollapse */
CmDropdown.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmDropdown = __decorate([
    ProxyCmp({ inputs: ["options", "trigger"], "methods": ["open", "close", "triggerOptionByIndex"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmDropdown);
let CmEntityList = class CmEntityList {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
CmEntityList.decorators = [
    { type: Component, args: [{ selector: "cm-entity-list", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["addScrollPadding", "columns", "createButtonDataAttributes", "createButtonLabel", "createHandler", "defaultSorting", "enableCreateButton", "entities", "groupOptions", "headline", "hideCreateButton", "hideSearch", "loading"] },] },
];
/** @nocollapse */
CmEntityList.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmEntityList = __decorate([
    ProxyCmp({ inputs: ["addScrollPadding", "columns", "createButtonDataAttributes", "createButtonLabel", "createHandler", "defaultSorting", "enableCreateButton", "entities", "groupOptions", "headline", "hideCreateButton", "hideSearch", "loading"], "methods": ["triggerEntityOption", "triggerGroupOption", "selectAll", "deselectAll", "selectIndex", "deselectIndex"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmEntityList);
let CmFilter = class CmFilter {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["cmFilterSelected"]);
    }
};
CmFilter.decorators = [
    { type: Component, args: [{ selector: "cm-filter", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["activeFilterIndex", "filters"] },] },
];
/** @nocollapse */
CmFilter.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmFilter = __decorate([
    ProxyCmp({ inputs: ["activeFilterIndex", "filters"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmFilter);
let CmFooter = class CmFooter {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
CmFooter.decorators = [
    { type: Component, args: [{ selector: "cm-footer", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["text"] },] },
];
/** @nocollapse */
CmFooter.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmFooter = __decorate([
    ProxyCmp({ inputs: ["text"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmFooter);
let CmForm = class CmForm {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["cmSubmit"]);
    }
};
CmForm.decorators = [
    { type: Component, args: [{ selector: "cm-form", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>" },] },
];
/** @nocollapse */
CmForm.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmForm = __decorate([
    ProxyCmp({ "methods": ["checkValidity", "getFormData", "attemptSubmit", "reset", "forceFocus"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmForm);
let CmFormGroup = class CmFormGroup {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
CmFormGroup.decorators = [
    { type: Component, args: [{ selector: "cm-form-group", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["label"] },] },
];
/** @nocollapse */
CmFormGroup.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmFormGroup = __decorate([
    ProxyCmp({ inputs: ["label"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmFormGroup);
class CmHeader {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
}
CmHeader.decorators = [
    { type: Component, args: [{ selector: "cm-header", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>" },] },
];
/** @nocollapse */
CmHeader.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
let CmIcon = class CmIcon {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
CmIcon.decorators = [
    { type: Component, args: [{ selector: "cm-icon", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["color", "icon", "ignoreTheme"] },] },
];
/** @nocollapse */
CmIcon.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmIcon = __decorate([
    ProxyCmp({ inputs: ["color", "icon", "ignoreTheme"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmIcon);
let CmIconButton = class CmIconButton {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["cmPress"]);
    }
};
CmIconButton.decorators = [
    { type: Component, args: [{ selector: "cm-icon-button", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["color", "disabled", "icon", "ignoreTheme"] },] },
];
/** @nocollapse */
CmIconButton.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmIconButton = __decorate([
    ProxyCmp({ inputs: ["color", "disabled", "icon", "ignoreTheme"], "methods": ["press"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmIconButton);
let CmLink = class CmLink {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
CmLink.decorators = [
    { type: Component, args: [{ selector: "cm-link", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["href", "label", "openIn"] },] },
];
/** @nocollapse */
CmLink.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmLink = __decorate([
    ProxyCmp({ inputs: ["href", "label", "openIn"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmLink);
let CmLoader = class CmLoader {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
CmLoader.decorators = [
    { type: Component, args: [{ selector: "cm-loader", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["size"] },] },
];
/** @nocollapse */
CmLoader.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmLoader = __decorate([
    ProxyCmp({ inputs: ["size"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmLoader);
class CmLogo {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
}
CmLogo.decorators = [
    { type: Component, args: [{ selector: "cm-logo", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>" },] },
];
/** @nocollapse */
CmLogo.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
let CmModal = class CmModal {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
CmModal.decorators = [
    { type: Component, args: [{ selector: "cm-modal", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["cancelAppearance", "cancelButtonDataAttributes", "cancelLabel", "closeButtonDataAttributes", "confirmAppearance", "confirmButtonDataAttributes", "confirmDisabled", "confirmLabel", "headline", "overrideMaximumWidth", "paddings", "position", "width"] },] },
];
/** @nocollapse */
CmModal.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmModal = __decorate([
    ProxyCmp({ inputs: ["cancelAppearance", "cancelButtonDataAttributes", "cancelLabel", "closeButtonDataAttributes", "confirmAppearance", "confirmButtonDataAttributes", "confirmDisabled", "confirmLabel", "headline", "overrideMaximumWidth", "paddings", "position", "width"], "methods": ["open", "confirm", "cancel"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmModal);
let CmNotification = class CmNotification {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["cmDismissed", "cmNotificationNavigation", "didLoad"]);
    }
};
CmNotification.decorators = [
    { type: Component, args: [{ selector: "cm-notification", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["appearance", "createdAt", "description", "headline", "navigationLabel", "showCreationTime", "userDismissable"] },] },
];
/** @nocollapse */
CmNotification.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmNotification = __decorate([
    ProxyCmp({ inputs: ["appearance", "createdAt", "description", "headline", "navigationLabel", "showCreationTime", "userDismissable"], "methods": ["dismiss", "isBeingHovered"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmNotification);
let CmNotificationContainer = class CmNotificationContainer {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
CmNotificationContainer.decorators = [
    { type: Component, args: [{ selector: "cm-notification-container", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>" },] },
];
/** @nocollapse */
CmNotificationContainer.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmNotificationContainer = __decorate([
    ProxyCmp({ "methods": ["enqueueNotification"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmNotificationContainer);
let CmPage = class CmPage {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["tabChanged"]);
    }
};
CmPage.decorators = [
    { type: Component, args: [{ selector: "cm-page", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["activeLabel"] },] },
];
/** @nocollapse */
CmPage.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmPage = __decorate([
    ProxyCmp({ inputs: ["activeLabel"], "methods": ["getActiveState", "switchToTab", "switchToTabIndex"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmPage);
let CmPageTab = class CmPageTab {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["tabModified"]);
    }
};
CmPageTab.decorators = [
    { type: Component, args: [{ selector: "cm-page-tab", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["active", "disableScroll", "label"] },] },
];
/** @nocollapse */
CmPageTab.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmPageTab = __decorate([
    ProxyCmp({ inputs: ["active", "disableScroll", "label"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmPageTab);
let CmPageTabHandle = class CmPageTabHandle {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["userSelectedTab"]);
    }
};
CmPageTabHandle.decorators = [
    { type: Component, args: [{ selector: "cm-page-tab-handle", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["active", "label"] },] },
];
/** @nocollapse */
CmPageTabHandle.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmPageTabHandle = __decorate([
    ProxyCmp({ inputs: ["active", "label"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmPageTabHandle);
let CmRadiobutton = class CmRadiobutton {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["cmSelected"]);
    }
};
CmRadiobutton.decorators = [
    { type: Component, args: [{ selector: "cm-radiobutton", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["disabled", "helperText", "label", "selected", "value"] },] },
];
/** @nocollapse */
CmRadiobutton.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmRadiobutton = __decorate([
    ProxyCmp({ inputs: ["disabled", "helperText", "label", "selected", "value"], "methods": ["select"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmRadiobutton);
let CmRadiobuttonGroup = class CmRadiobuttonGroup {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["cmInput"]);
    }
};
CmRadiobuttonGroup.decorators = [
    { type: Component, args: [{ selector: "cm-radiobutton-group", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["formName", "label", "value"] },] },
];
/** @nocollapse */
CmRadiobuttonGroup.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmRadiobuttonGroup = __decorate([
    ProxyCmp({ inputs: ["formName", "label", "value"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmRadiobuttonGroup);
let CmSelect = class CmSelect {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["cmInput", "cmReset"]);
    }
};
CmSelect.decorators = [
    { type: Component, args: [{ selector: "cm-select", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["allowMultiple", "disabled", "fieldPrefix", "formName", "helperText", "label", "labelAlignment", "options", "placeholder", "preventVerticalExpansion", "required", "selectedOptions", "showRequired", "validation", "validationStyle"] },] },
];
/** @nocollapse */
CmSelect.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmSelect = __decorate([
    ProxyCmp({ inputs: ["allowMultiple", "disabled", "fieldPrefix", "formName", "helperText", "label", "labelAlignment", "options", "placeholder", "preventVerticalExpansion", "required", "selectedOptions", "showRequired", "validation", "validationStyle"], "methods": ["reset", "forceFocus", "checkValidity", "renderValidity", "hideValidity"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmSelect);
let CmSelectFlyout = class CmSelectFlyout {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["cmInput"]);
    }
};
CmSelectFlyout.decorators = [
    { type: Component, args: [{ selector: "cm-select-flyout", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["isOpen", "options", "select", "selectedOptions"] },] },
];
/** @nocollapse */
CmSelectFlyout.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmSelectFlyout = __decorate([
    ProxyCmp({ inputs: ["isOpen", "options", "select", "selectedOptions"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmSelectFlyout);
let CmText = class CmText {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
CmText.decorators = [
    { type: Component, args: [{ selector: "cm-text", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["appearance", "color"] },] },
];
/** @nocollapse */
CmText.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmText = __decorate([
    ProxyCmp({ inputs: ["appearance", "color"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmText);
let CmTextfield = class CmTextfield {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["cmInput", "cmReset"]);
    }
};
CmTextfield.decorators = [
    { type: Component, args: [{ selector: "cm-textfield", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["autocomplete", "disabled", "fieldPrefix", "fieldSuffix", "formName", "helperText", "label", "labelAlignment", "max", "maxLength", "min", "placeholder", "required", "rows", "showRequired", "step", "type", "validation", "validationStyle", "value", "valueAsNumber"] },] },
];
/** @nocollapse */
CmTextfield.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmTextfield = __decorate([
    ProxyCmp({ inputs: ["autocomplete", "disabled", "fieldPrefix", "fieldSuffix", "formName", "helperText", "label", "labelAlignment", "max", "maxLength", "min", "placeholder", "required", "rows", "showRequired", "step", "type", "validation", "validationStyle", "value", "valueAsNumber"], "methods": ["reset", "forceFocus", "checkValidity", "renderValidity", "hideValidity"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmTextfield);
let CmToggle = class CmToggle {
    /**
     * @param {?} c
     * @param {?} r
     * @param {?} z
     */
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ["cmInput"]);
    }
};
CmToggle.decorators = [
    { type: Component, args: [{ selector: "cm-toggle", changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["checked", "disabled", "enableAttributeEmit", "label"] },] },
];
/** @nocollapse */
CmToggle.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
CmToggle = __decorate([
    ProxyCmp({ inputs: ["checked", "disabled", "enableAttributeEmit", "label"], "methods": ["toggleCheck", "check", "uncheck"] }),
    __metadata("design:paramtypes", [ChangeDetectorRef, ElementRef, NgZone])
], CmToggle);

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
defineCustomElements(window);
/** @type {?} */
const DECLARATIONS = [
    CmBanner,
    CmIconButton,
    CmContext,
    CmLoader,
    CmButton,
    CmCheckbox,
    CmToggle,
    CmSelect,
    CmSelectFlyout,
    CmLink,
    CmText,
    CmFooter,
    CmHeader,
    CmIcon,
    CmModal,
    CmLogo,
    CmPage,
    CmPageTab,
    CmPageTabHandle,
    CmDatalist,
    CmDatalistItem,
    CmNotification,
    CmNotificationContainer,
    CmEntityList,
    CmDropdown,
    CmCard,
    CmFilter,
    CmRadiobutton,
    CmRadiobuttonGroup,
    CmForm,
    CmFormGroup,
    CmCheckboxGroup,
    CmTextfield,
];
class CommonUiModule {
}
CommonUiModule.decorators = [
    { type: NgModule, args: [{
                declarations: DECLARATIONS,
                exports: DECLARATIONS,
                imports: [],
                providers: [],
            },] },
];

export { CmBanner, CmButton, CmCard, CmCheckbox, CmCheckboxGroup, CmContext, CmDatalist, CmDatalistItem, CmDropdown, CmEntityList, CmFilter, CmFooter, CmForm, CmFormGroup, CmHeader, CmIcon, CmIconButton, CmLink, CmLoader, CmLogo, CmModal, CmNotification, CmNotificationContainer, CmPage, CmPageTab, CmPageTabHandle, CmRadiobutton, CmRadiobuttonGroup, CmSelect, CmSelectFlyout, CmText, CmTextfield, CmToggle, CommonUiModule, ProxyCmp as ɵa };
